/*
 *  Copyright 2019, Antoine Fontaine <antoine.fontaine@epfl.ch>
 *  I release this program under GNU GPLv3+.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#pragma once

#include <glib.h>

struct Courses {
  struct Course *courses;
  size_t course_count;
};

struct Course {
  gchar* name;
  gchar* url;
  guint id;
};

struct CourseContent {
  guint week_count;
  struct Week* weeks;
};

struct Week {
  guint week_number;
  guint file_count;
  struct DownloadableFile* files;
};

struct DownloadableFile {
  gchar* textname;
  gchar* name;
  guint id;
};
