/*
 *  Copyright 2019, Antoine Fontaine <antoine.fontaine@epfl.ch>
 *  I release this program under GNU GPLv3+.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#pragma once

#include "data-struct.h"

typedef void (*courses_cb)       (gpointer user_data, struct Courses);
typedef void (*course_content_cb)(gpointer user_data, struct CourseContent);
typedef void (*file_cb)          (gpointer user_data, const char *filename);

enum moodle_error {
  MOODLE_ERROR_OK,
  MOODLE_ERROR_CONNECTION,
  MOODLE_ERROR_AUTH,
};

typedef enum moodle_online_mode {
  MOODLE_MODE_ONLINE,
  MOODLE_MODE_OFFLINE,
} MoodleOnlineMode;

enum moodle_error moodle_provider_init (courses_cb       cb,
                                        MoodleOnlineMode offline_mode,
                                        gpointer         cb_arg);

void moodle_provider_download_file (guint id, file_cb cb, gpointer cb_arg);

enum moodle_error moodle_provider_get_courses (courses_cb cb,
                                               gpointer   cb_arg);
enum moodle_error moodle_provider_get_course_content (course_content_cb cb,
                                                      guint             id,
                                                      gpointer          cb_arg);

